//*!!Sensor,    S2,      photoelectrique, sensorLightActive,      ,              !!*//
//*!!                                                                            !!*//
//*!!Start automatically generated configuration code.                           !!*//
const tSensors photoelectrique      = (tSensors) S2;   //sensorLightActive  //*!!!!*//
//*!!CLICK to edit 'wizard' created sensor & motor configuration.                !!*//

//******************************************************************************************//
// Le robot suit le cote gauche d'une ligne en fonction des informations donnees par	      //
// le capteur de luminosite. Si le niveau de luminosite lu est en deca du seuil, c'est 	    //
// que le robot est sur une surface noire (ligne). Alors, il tourne vers la gauche jusqu'	//
// trouver une surface plus claire,  ce moment il retourne sur la droite. En avancant	    //
// de gauche a droite le robot realise un mouvement " linaire " le long de la ligne noire.	//
//******************************************************************************************//
const tSensors lightsensor = (tSensors) S1;   //nommer "lightsensor" le capteur sur le port S1
int lineThreshold ;															// declarer variable "seuil" en nombre entier

task pingTask {																	// definir la tache sons "pingTask"
	ClearSounds () ;															// eteindre tout son
	while (true) {																// tant que la tempo de 1s n'est pas acheve
		PlaySound(soundBlip) ;											// faire le son "Blip" toutes les 1s
		wait10Msec (100);														// tempo 100*10 ms = 1s
	}
}
void waitForEnterButton()												// fonction gestion des touches orange (validation)
{																								// et grise (devalidation)
	StartTask (pingTask) ;												// lancer la tache "pingTask"
	while (nNxtButtonPressed != kEnterButton) ;				// tant que le bouton orange n'est pas appuye
	while (nNxtButtonPressed != kNoButton) ;					// tant que le bouton orange n'est pas appuye
	StopTask (pingTask) ;													// fin pingTask
}

task main()
{
  {
	eraseDisplay() ;																		// effacer tout affichage de l'ecran LCD
	nxtDisplayCenteredTextLine(0, "CALIBRATION") ;			// afficher CALIBRATION centre en ligne 0
	nxtDisplayTextLine(1, "- white lvl :") ;						// afficher - White lvl (niv blanc) en ligne 1
	nxtDisplayCenteredTextLine(7, "Press ENTER key") ;	// afficher Press ENTER key
	waitForEnterButton() ;															// lancer tache d'attente d'action sur ENTER
	int lvlWhite = SensorValue(S1) ;										// variable lvlWhite recoit valeur lue par S1
	nxtDisplayTextLine(1, "- white lvl : %d", lvlWhite) ; // afficher valeur niveau blanc

	nxtDisplayTextLine(2, "- black lvl :") ;						// meme procedure pour le niveau noir
	waitForEnterButton() ;
	int lvlBlack = SensorValue(lightsensor) ;
	nxtDisplayTextLine(2, "- black lvl : %d", lvlBlack) ;

	lineThreshold = (lvlWhite + lvlBlack) / 2 ;					// valeur seuil de declenchement

	nxtDisplayCenteredTextLine(4, "Robot OK ?") ;				// Demander si le robot est pret a demarrer
	waitForEnterButton() ;															// procedure d'attente de confirmation (son)
	}
	while(true)																					//boucle infinie
   {
      if(SensorValue(lightsensor) < lineThreshold)  // si valeur capteur lue < seuil faire
      {
        motor[motorA] = -75;            										//moteur A a -75% de puissance
	 			motor[motorC] = 0;              										//moteur C arrete
      }

      else                               							// sinon (valeur capteur lue >= seuil) faire
      {
        motor[motorA] = 0;              										//moteur A arrete
	 			motor[motorC] = -75;            										//moteur C a -75% de puissance
      }
   }
}
